diff --git a/kernel/socket.c b/kernel/socket.c
index 0414d7a6ce74141cd2ca365bfd1da727691e27ec..ccf98aa7e1f9c52fd002a1c4074b053a89ffeec3 100644
--- a/kernel/socket.c
+++ b/kernel/socket.c
@@ -1,25 +1,58 @@
 // SPDX-License-Identifier: GPL-2.0
 /*
  * Copyright (C) 2015-2019 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.
+ * TCP Support Copyright (c) 2024-2026 Jeff Nathan and Dragos Ruiu. All Rights Reserved.
  */
 
+
 #include "device.h"
 #include "peer.h"
 #include "socket.h"
+#include "wg_tcp.h"
 #include "queueing.h"
 #include "messages.h"
 
+#include <asm/byteorder.h> /* For ntohl */
 #include <linux/ctype.h>
-#include <linux/net.h>
+#include <linux/delay.h>
 #include <linux/if_vlan.h>
 #include <linux/if_ether.h>
 #include <linux/inetdevice.h>
+#include <linux/wireguard.h>
+#include <linux/kernel.h>
+#include <linux/moduleparam.h>
+#include <linux/skbuff.h>
+#include <linux/net.h>
+#include <linux/tcp.h>
+#include <linux/time.h>
+#include <linux/ktime.h>
+#include <linux/in.h>
+#include <linux/inet.h>
+#include <linux/kthread.h>
+#include <linux/workqueue.h>
+#include <linux/spinlock.h>
+#include <linux/lockdep.h>
+#include <linux/socket.h>
+#include <linux/in6.h>
+#include <net/checksum.h>
 #include <net/udp_tunnel.h>
 #include <net/ipv6.h>
+#include <net/sock.h>
+#include <net/udp.h>
+#include <net/inet_sock.h>
+#include <net/inet_common.h>
+#include <net/tcp.h>
+#include <linux/jiffies.h>
+#include <net/inet_connection_sock.h>
+#include <linux/version.h>
+#include "wg_tcp_debug.h"
 
 static int send4(struct wg_device *wg, struct sk_buff *skb,
 		 struct endpoint *endpoint, u8 ds, struct dst_cache *cache)
 {
+	wg_dbg("Entering function send4\n");
+
+
 	struct flowi4 fl = {
 		.saddr = endpoint->src4.s_addr,
 		.daddr = endpoint->addr4.sin_addr.s_addr,
@@ -71,11 +104,17 @@ static int send4(struct wg_device *wg, struct sk_buff *skb,
 				ip_rt_put(rt);
 			rt = ip_route_output_flow(sock_net(sock), &fl, sock);
 		}
-		if (IS_ERR(rt)) {
+		if (unlikely(IS_ERR(rt))) {
 			ret = PTR_ERR(rt);
 			net_dbg_ratelimited("%s: No route to %pISpfsc, error %d\n",
 					    wg->dev->name, &endpoint->addr, ret);
 			goto err;
+		} else if (unlikely(rt->dst.dev == skb->dev)) {
+			ip_rt_put(rt);
+			ret = -ELOOP;
+			net_dbg_ratelimited("%s: Avoiding routing loop to %pISpfsc\n",
+					    wg->dev->name, &endpoint->addr);
+			goto err;
 		}
 		if (cache)
 			dst_cache_set_ip4(cache, &rt->dst, fl.saddr);
@@ -91,13 +130,17 @@ err:
 	kfree_skb(skb);
 out:
 	rcu_read_unlock_bh();
+	wg_dbg("Exiting function send4\n");
 	return ret;
 }
 
 static int send6(struct wg_device *wg, struct sk_buff *skb,
 		 struct endpoint *endpoint, u8 ds, struct dst_cache *cache)
 {
+	wg_dbg("Entering function send6\n");
 #if IS_ENABLED(CONFIG_IPV6)
+
+
 	struct flowi6 fl = {
 		.saddr = endpoint->src6,
 		.daddr = endpoint->addr6.sin6_addr,
@@ -138,11 +181,17 @@ static int send6(struct wg_device *wg, struct sk_buff *skb,
 		}
 		dst = ipv6_stub->ipv6_dst_lookup_flow(sock_net(sock), sock, &fl,
 						      NULL);
-		if (IS_ERR(dst)) {
+		if (unlikely(IS_ERR(dst))) {
 			ret = PTR_ERR(dst);
 			net_dbg_ratelimited("%s: No route to %pISpfsc, error %d\n",
 					    wg->dev->name, &endpoint->addr, ret);
 			goto err;
+		} else if (unlikely(dst->dev == skb->dev)) {
+			dst_release(dst);
+			ret = -ELOOP;
+			net_dbg_ratelimited("%s: Avoiding routing loop to %pISpfsc\n",
+					    wg->dev->name, &endpoint->addr);
+			goto err;
 		}
 		if (cache)
 			dst_cache_set_ip6(cache, dst, &fl.saddr);
@@ -158,52 +207,68 @@ err:
 	kfree_skb(skb);
 out:
 	rcu_read_unlock_bh();
+	wg_dbg("Exiting function send6\n");
 	return ret;
 #else
 	kfree_skb(skb);
+	wg_dbg("Exiting function send6\n");
 	return -EAFNOSUPPORT;
 #endif
 }
 
-int wg_socket_send_skb_to_peer(struct wg_peer *peer, struct sk_buff *skb, u8 ds)
+int wg_socket_send_skb_to_endpoint(struct wg_device *wg,
+				   struct sk_buff *skb,
+				   struct endpoint *endpoint, u8 ds,
+				   struct dst_cache *cache)
 {
-	size_t skb_len = skb->len;
-	int ret = -EAFNOSUPPORT;
-
-	read_lock_bh(&peer->endpoint_lock);
-	if (peer->endpoint.addr.sa_family == AF_INET)
-		ret = send4(peer->device, skb, &peer->endpoint, ds,
-			    &peer->endpoint_cache);
-	else if (peer->endpoint.addr.sa_family == AF_INET6)
-		ret = send6(peer->device, skb, &peer->endpoint, ds,
-			    &peer->endpoint_cache);
-	else
-		dev_kfree_skb(skb);
-	if (likely(!ret))
-		peer->tx_bytes += skb_len;
-	read_unlock_bh(&peer->endpoint_lock);
+	if (endpoint->addr.sa_family == AF_INET)
+		return send4(wg, skb, endpoint, ds, cache);
+	if (endpoint->addr.sa_family == AF_INET6)
+		return send6(wg, skb, endpoint, ds, cache);
 
-	return ret;
+	dev_kfree_skb(skb);
+	return -EAFNOSUPPORT;
 }
 
 int wg_socket_send_buffer_to_peer(struct wg_peer *peer, void *buffer,
 				  size_t len, u8 ds)
 {
-	struct sk_buff *skb = alloc_skb(len + SKB_HEADER_LEN, GFP_ATOMIC);
+	int ret;
+	struct sk_buff *skb;
 
-	if (unlikely(!skb))
-		return -ENOMEM;
+	wg_dbg("Entering function wg_socket_send_buffer_to_peer peer=%px\n", peer);
+
+	/* BUG FIX: null check peer BEFORE dereferencing it */
+	if (unlikely(!peer) || unlikely(IS_ERR(peer))) {
+		ret = -EINVAL;
+		goto out;
+	}
+
+	log_wireguard_endpoint(&peer->endpoint);
+	skb = alloc_skb(len + SKB_HEADER_LEN, GFP_ATOMIC);
+
+	wg_dbg("Sending buffer to peer - Length: %zu, Data: %*ph\n",
+		len, (int)len, buffer);
+	if (unlikely(!skb)){
+		ret = -ENOMEM;
+		goto out;
+	}
 
 	skb_reserve(skb, SKB_HEADER_LEN);
 	skb_set_inner_network_header(skb, 0);
 	skb_put_data(skb, buffer, len);
-	return wg_socket_send_skb_to_peer(peer, skb, ds);
+	ret = wg_socket_send_skb_to_peer(peer, skb, ds);
+
+out:
+	wg_dbg("Exiting function wg_socket_send_buffer_to_peer\n");
+	return ret;
 }
 
 int wg_socket_send_buffer_as_reply_to_skb(struct wg_device *wg,
 					  struct sk_buff *in_skb, void *buffer,
 					  size_t len)
 {
+	wg_dbg("Entering function wg_socket_send_buffer_as_reply_to_skb\n");
 	int ret = 0;
 	struct sk_buff *skb;
 	struct endpoint endpoint;
@@ -221,20 +286,19 @@ int wg_socket_send_buffer_as_reply_to_skb(struct wg_device *wg,
 	skb_set_inner_network_header(skb, 0);
 	skb_put_data(skb, buffer, len);
 
-	if (endpoint.addr.sa_family == AF_INET)
-		ret = send4(wg, skb, &endpoint, 0, NULL);
-	else if (endpoint.addr.sa_family == AF_INET6)
-		ret = send6(wg, skb, &endpoint, 0, NULL);
-	/* No other possibilities if the endpoint is valid, which it is,
-	 * as we checked above.
-	 */
+	ret = wg_socket_send_skb_to_endpoint(wg, skb, &endpoint, 0, NULL);
 
+	wg_dbg("Exiting function wg_socket_send_buffer_as_reply_to_skb\n");
 	return ret;
 }
 
-int wg_socket_endpoint_from_skb(struct endpoint *endpoint,
-				const struct sk_buff *skb)
+
+int wg_socket_endpoint_from_skb(struct endpoint *endpoint, const struct sk_buff *skb)
 {
+	wg_dbg("Entering function wg_socket_endpoint_from_skb\n");
+
+	wg_dbg("skb data: %*ph\n", min_t(int, skb->len, 128), skb->data);
+
 	memset(endpoint, 0, sizeof(*endpoint));
 	if (skb->protocol == htons(ETH_P_IP)) {
 		endpoint->addr4.sin_family = AF_INET;
@@ -242,21 +306,29 @@ int wg_socket_endpoint_from_skb(struct endpoint *endpoint,
 		endpoint->addr4.sin_addr.s_addr = ip_hdr(skb)->saddr;
 		endpoint->src4.s_addr = ip_hdr(skb)->daddr;
 		endpoint->src_if4 = skb->skb_iif;
+		wg_dbg("wg_socket_endpoint_from_skb: Extracted IPv4 address %pI4:%d\n",
+		       &endpoint->addr4.sin_addr, ntohs(endpoint->addr4.sin_port));
 	} else if (IS_ENABLED(CONFIG_IPV6) && skb->protocol == htons(ETH_P_IPV6)) {
 		endpoint->addr6.sin6_family = AF_INET6;
 		endpoint->addr6.sin6_port = udp_hdr(skb)->source;
 		endpoint->addr6.sin6_addr = ipv6_hdr(skb)->saddr;
-		endpoint->addr6.sin6_scope_id = ipv6_iface_scope_id(
-			&ipv6_hdr(skb)->saddr, skb->skb_iif);
+		endpoint->addr6.sin6_scope_id = ipv6_iface_scope_id(&ipv6_hdr(skb)->saddr, skb->skb_iif);
 		endpoint->src6 = ipv6_hdr(skb)->daddr;
+		wg_dbg("wg_socket_endpoint_from_skb: Extracted IPv6 address %pI6c:%d\n",
+		       &endpoint->addr6.sin6_addr, ntohs(endpoint->addr6.sin6_port));
 	} else {
 		return -EINVAL;
 	}
+
+
+	wg_dbg("Exiting function wg_socket_endpoint_from_skb\n");
 	return 0;
 }
 
-static bool endpoint_eq(const struct endpoint *a, const struct endpoint *b)
+bool endpoint_eq(const struct endpoint *a, const struct endpoint *b)
 {
+	wg_dbg("Entering function endpoint_eq\n");
+	wg_dbg("Exiting function endpoint_eq\n");
 	return (a->addr.sa_family == AF_INET && b->addr.sa_family == AF_INET &&
 		a->addr4.sin_port == b->addr4.sin_port &&
 		a->addr4.sin_addr.s_addr == b->addr4.sin_addr.s_addr &&
@@ -269,57 +341,32 @@ static bool endpoint_eq(const struct endpoint *a, const struct endpoint *b)
 		ipv6_addr_equal(&a->src6, &b->src6)) ||
 	       unlikely(!a->addr.sa_family && !b->addr.sa_family);
 }
-
-void wg_socket_set_peer_endpoint(struct wg_peer *peer,
-				 const struct endpoint *endpoint)
+static void sock_free(struct sock *sock)
 {
-	/* First we check unlocked, in order to optimize, since it's pretty rare
-	 * that an endpoint will change. If we happen to be mid-write, and two
-	 * CPUs wind up writing the same thing or something slightly different,
-	 * it doesn't really matter much either.
-	 */
-	if (endpoint_eq(endpoint, &peer->endpoint))
+	wg_dbg("Entering function sock_free\n");
+	if (unlikely(!sock))
 		return;
-	write_lock_bh(&peer->endpoint_lock);
-	if (endpoint->addr.sa_family == AF_INET) {
-		peer->endpoint.addr4 = endpoint->addr4;
-		peer->endpoint.src4 = endpoint->src4;
-		peer->endpoint.src_if4 = endpoint->src_if4;
-	} else if (IS_ENABLED(CONFIG_IPV6) && endpoint->addr.sa_family == AF_INET6) {
-		peer->endpoint.addr6 = endpoint->addr6;
-		peer->endpoint.src6 = endpoint->src6;
-	} else {
-		goto out;
-	}
-	dst_cache_reset(&peer->endpoint_cache);
-out:
-	write_unlock_bh(&peer->endpoint_lock);
-}
-
-void wg_socket_set_peer_endpoint_from_skb(struct wg_peer *peer,
-					  const struct sk_buff *skb)
-{
-	struct endpoint endpoint;
-
-	if (!wg_socket_endpoint_from_skb(&endpoint, skb))
-		wg_socket_set_peer_endpoint(peer, &endpoint);
+	sk_clear_memalloc(sock);
+	udp_tunnel_sock_release(sock->sk_socket);
+	wg_dbg("Exiting function sock_free\n");
 }
 
-void wg_socket_clear_peer_endpoint_src(struct wg_peer *peer)
+static void set_sock_opts(struct socket *sock)
 {
-	write_lock_bh(&peer->endpoint_lock);
-	memset(&peer->endpoint.src6, 0, sizeof(peer->endpoint.src6));
-	dst_cache_reset_now(&peer->endpoint_cache);
-	write_unlock_bh(&peer->endpoint_lock);
+	wg_dbg("Entering function set_sock_opts\n");
+	sock->sk->sk_allocation = GFP_ATOMIC;
+	sock->sk->sk_sndbuf = INT_MAX;
+	sk_set_memalloc(sock->sk);
+	wg_dbg("Exiting function set_sock_opts\n");
 }
 
-static int wg_receive(struct sock *sk, struct sk_buff *skb)
+static int wg_udp_receive(struct sock *sk, struct sk_buff *skb)
 {
 	struct wg_device *wg;
 
 	if (unlikely(!sk))
 		goto err;
-	wg = sk->sk_user_data;
+	wg = READ_ONCE(sk->sk_user_data);
 	if (unlikely(!wg))
 		goto err;
 	skb_mark_not_on_list(skb);
@@ -331,29 +378,15 @@ err:
 	return 0;
 }
 
-static void sock_free(struct sock *sock)
-{
-	if (unlikely(!sock))
-		return;
-	sk_clear_memalloc(sock);
-	udp_tunnel_sock_release(sock->sk_socket);
-}
-
-static void set_sock_opts(struct socket *sock)
-{
-	sock->sk->sk_allocation = GFP_ATOMIC;
-	sock->sk->sk_sndbuf = INT_MAX;
-	sk_set_memalloc(sock->sk);
-}
-
 int wg_socket_init(struct wg_device *wg, u16 port)
 {
+	wg_dbg("Entering function wg_socket_init\n");
 	struct net *net;
 	int ret;
 	struct udp_tunnel_sock_cfg cfg = {
 		.sk_user_data = wg,
 		.encap_type = 1,
-		.encap_rcv = wg_receive
+		.encap_rcv = wg_udp_receive
 	};
 	struct socket *new4 = NULL, *new6 = NULL;
 	struct udp_port_cfg port4 = {
@@ -390,6 +423,7 @@ retry:
 		goto out;
 	}
 	set_sock_opts(new4);
+
 	setup_udp_tunnel_sock(net, new4, &cfg);
 
 #if IS_ENABLED(CONFIG_IPV6)
@@ -405,6 +439,8 @@ retry:
 			goto out;
 		}
 		set_sock_opts(new6);
+
+		/* Setup the IPv6 UDP tunnel socket with the same socket data */
 		setup_udp_tunnel_sock(net, new6, &cfg);
 	}
 #endif
@@ -413,12 +449,15 @@ retry:
 	ret = 0;
 out:
 	put_net(net);
+	wg_dbg("Exiting function wg_socket_init\n");
 	return ret;
 }
 
+
 void wg_socket_reinit(struct wg_device *wg, struct sock *new4,
 		      struct sock *new6)
 {
+	wg_dbg("Entering function wg_socket_reinit\n");
 	struct sock *old4, *old6;
 
 	mutex_lock(&wg->socket_update_lock);
@@ -431,7 +470,9 @@ void wg_socket_reinit(struct wg_device *wg, struct sock *new4,
 	if (new4)
 		wg->incoming_port = ntohs(inet_sk(new4)->inet_sport);
 	mutex_unlock(&wg->socket_update_lock);
+	synchronize_rcu();
 	synchronize_net();
 	sock_free(old4);
 	sock_free(old6);
+	wg_dbg("Exiting function wg_socket_reinit\n");
 }
diff --git a/kernel/socket.h b/kernel/socket.h
index bab5848efbcdfe59056115c132caa0f618148288..166674686fe904518069ca33939c7717ea31bc3d 100644
--- a/kernel/socket.h
+++ b/kernel/socket.h
@@ -1,11 +1,13 @@
 /* SPDX-License-Identifier: GPL-2.0 */
 /*
  * Copyright (C) 2015-2019 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.
+ * TCP Support Copyright (c) 2024 Jeff Nathan and Dragos Ruiu. All Rights Reserved.
  */
 
 #ifndef _WG_SOCKET_H
 #define _WG_SOCKET_H
 
+#include <linux/net.h>
 #include <linux/netdevice.h>
 #include <linux/udp.h>
 #include <linux/if_vlan.h>
@@ -16,19 +18,53 @@ void wg_socket_reinit(struct wg_device *wg, struct sock *new4,
 		      struct sock *new6);
 int wg_socket_send_buffer_to_peer(struct wg_peer *peer, void *data,
 				  size_t len, u8 ds);
-int wg_socket_send_skb_to_peer(struct wg_peer *peer, struct sk_buff *skb,
-			       u8 ds);
 int wg_socket_send_buffer_as_reply_to_skb(struct wg_device *wg,
 					  struct sk_buff *in_skb,
 					  void *out_buffer, size_t len);
 
 int wg_socket_endpoint_from_skb(struct endpoint *endpoint,
 				const struct sk_buff *skb);
-void wg_socket_set_peer_endpoint(struct wg_peer *peer,
-				 const struct endpoint *endpoint);
-void wg_socket_set_peer_endpoint_from_skb(struct wg_peer *peer,
-					  const struct sk_buff *skb);
-void wg_socket_clear_peer_endpoint_src(struct wg_peer *peer);
+int wg_socket_send_skb_to_endpoint(struct wg_device *wg,
+				   struct sk_buff *skb,
+				   struct endpoint *endpoint, u8 ds,
+				   struct dst_cache *cache);
+
+struct wg_tcp_encap_header {
+	__be32 length;
+	__u8 type;
+	__u8 flags;
+	__be16 checksum;
+};
+
+struct wg_tcp_frag_header {
+	__be16 id;
+	__be16 frag_off;
+};
+
+struct wg_tcp_socket_list_entry {
+	struct socket *tcp_socket; /* Socket associated with the connection */
+	struct sockaddr_storage src_addr; /* Source address for the connection */
+	struct wg_peer *temp_peer; /* temporary peer for dataready */
+	struct list_head tcp_connection_ll; /* List pointer for the linked list */
+	ktime_t created_at; /* Absolute pre-authentication deadline base */
+	ktime_t timestamp; /* Most recent pre-authentication activity */
+	u64 connection_id; /* Stable carrier identity across async auth */
+	bool authenticated; /* Exact stream carried valid Noise traffic */
+	bool admission_counted; /* Owns one pre-authentication reservation */
+	bool initializing; /* Listener still owns callback handoff */
+};
+
+#define WG_TCP_ENCAP_HDR_LEN sizeof(struct wg_tcp_encap_header)
+#define WG_TCP_FRAG_HDR_LEN sizeof(struct wg_tcp_frag_header)
+#define WG_MAX_PACKET_SIZE 65535 + WG_TCP_ENCAP_HDR_LEN
+#define WG_TCP_SKB_READ_ALLOC_SIZE 8192 * 3
+/* A nominal 128 bytes to account for various
+ * stacked headers in any given Ethernet frame
+ */
+#define WG_TCP_RESERVED_HEADER_SIZE 128
+#define WG_TCP_RECORD_DATA 0
+/* Flags */
+#define WG_TCP_FRAG_FLAG 0x1
 
 #if defined(CONFIG_DYNAMIC_DEBUG) || defined(DEBUG)
 #define net_dbg_skb_ratelimited(fmt, dev, skb, ...) do {                       \
@@ -41,4 +77,9 @@ void wg_socket_clear_peer_endpoint_src(struct wg_peer *peer);
 #define net_dbg_skb_ratelimited(fmt, skb, ...)
 #endif
 
+void wg_tcp_connection_retry_timer(struct timer_list *);
+
+bool endpoint_eq(const struct endpoint *a, const struct endpoint *b);
+void wg_print_wireguard_skb(const struct sk_buff *skb);
+
 #endif /* _WG_SOCKET_H */
diff --git a/kernel/timers.c b/kernel/timers.c
index 968bdb4df0b300d12abf6fe4e1858225b3caf044..5daf66f957c4e513451a7f55616cc78e90837c9e 100644
--- a/kernel/timers.c
+++ b/kernel/timers.c
@@ -8,6 +8,7 @@
 #include "peer.h"
 #include "queueing.h"
 #include "socket.h"
+#include "wg_tcp.h"
 
 /*
  * - Timer for retransmitting the handshake if we don't hear back after
diff --git a/kernel/wg_tcp.h b/kernel/wg_tcp.h
new file mode 100644
index 0000000000000000000000000000000000000000..ffc96089b8684e508a12f803209baf4c07105603
--- /dev/null
+++ b/kernel/wg_tcp.h
@@ -0,0 +1,88 @@
+/* SPDX-License-Identifier: GPL-2.0 */
+/*
+ * Copyright (c) 2024-2026 Jeff Nathan and Dragos Ruiu. All Rights Reserved.
+ */
+
+#ifndef _WG_TCP_H
+#define _WG_TCP_H
+
+#include <linux/stddef.h>
+#include <linux/types.h>
+
+struct endpoint;
+struct net;
+struct sk_buff;
+struct sock;
+struct socket;
+struct work_struct;
+struct wg_device;
+struct wg_peer;
+struct wg_tcp_encap_header;
+
+struct wg_socket_data {
+	struct wg_device *device;
+	struct wg_peer *peer;
+	struct socket *socket;
+	bool inbound;
+	void (*original_state_change)(struct sock *sk);
+	void (*original_write_space)(struct sock *sk);
+	void (*original_data_ready)(struct sock *sk);
+};
+
+int wg_socket_send_skb_to_peer(struct wg_peer *peer, struct sk_buff *skb,
+			       u8 ds);
+void wg_socket_set_peer_endpoint(struct wg_peer *peer,
+				 const struct endpoint *endpoint);
+void wg_socket_set_peer_endpoint_configured(struct wg_peer *peer,
+					    const struct endpoint *endpoint);
+void wg_socket_set_peer_endpoint_authenticated(struct wg_peer *peer,
+					       const struct endpoint *endpoint,
+					       u64 connection_id);
+void wg_socket_set_peer_endpoint_authenticated_from_skb(
+	struct wg_peer *peer, const struct sk_buff *skb);
+void wg_socket_set_peer_endpoint_from_skb(struct wg_peer *peer,
+					  const struct sk_buff *skb);
+void wg_socket_clear_peer_endpoint_src(struct wg_peer *peer);
+void log_wireguard_endpoint(struct endpoint *endpoint);
+
+void wg_destruct_tcp_connection_list(struct wg_device *wg);
+void print_peer_socket_info(struct wg_peer *peer);
+void wg_tcp_state_change(struct sock *sk);
+void wg_extract_endpoint_from_sock(struct sock *sk, struct endpoint *endpoint);
+bool wg_check_potential_header_validity(struct wg_tcp_encap_header *hdr,
+					size_t remaining_len);
+
+int wg_tcp_queuepkt(struct wg_peer *peer, const void *data, size_t len);
+void wg_tcp_write_space(struct sock *sk);
+void wg_tcp_data_ready(struct sock *sk);
+void wg_tcp_inbound_remove_worker(struct work_struct *work);
+void wg_tcp_outbound_remove_worker(struct work_struct *work);
+int wg_add_tcp_socket_to_list(struct wg_device *wg, struct socket *sock,
+			      struct wg_peer *temp_peer);
+void wg_remove_from_tcp_connection_list(struct wg_device *wg,
+					struct socket *sock);
+
+int wg_tcp_listener_socket_init(struct wg_device *wg, u16 port);
+void wg_tcp_listener_socket_release(struct wg_device *wg);
+int wg_tcp_connect(struct wg_peer *peer);
+int wg_tcp_listener_worker(struct wg_device *wg, struct socket *tcp_socket);
+int wg_setup_tcp_listen4(struct wg_device *wg, struct net *net, u16 port,
+			 struct socket **listen_socket);
+int wg_setup_tcp_listen6(struct wg_device *wg, struct net *net, u16 port,
+			 struct socket **listen_socket);
+int wg_tcp_listener4_thread(void *data);
+int wg_tcp_listener6_thread(void *data);
+
+void wg_clean_peer_socket(struct wg_peer *peer, bool release, bool destroy,
+			  bool inbound);
+void wg_tcp_peer_stop(struct wg_peer *peer);
+void wg_tcp_peer_request_reconnect(struct wg_peer *peer);
+void wg_tcp_set_device_mark(struct wg_device *wg, u32 mark);
+void wg_tcp_write_worker(struct work_struct *work);
+void wg_tcp_read_worker(struct work_struct *work);
+void wg_tcp_bootstrap_worker(struct work_struct *work);
+void wg_tcp_promotion_worker(struct work_struct *work);
+void wg_tcp_cleanup_worker(struct work_struct *work);
+void wg_tcp_retry_worker(struct work_struct *work);
+
+#endif /* _WG_TCP_H */
